%define _requires_exceptions perl(Carp::Heavy)

%define snap	20040916

%define name	asterisk
%define version	1.0.1
#%define release	0.%{snap}.3mdk
%define release	2mdk

Summary:	Asterisk PBX
Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	GPL
Group:		System/Servers
URL:		http://www.asterisk.org/
#Source0:	%{name}-%{version}-%{snap}.tar.bz2
Source0:	%{name}-%{version}.tar.bz2
Source1:	asterisk.init.bz2
# http://www.asteriskdocs.org/modules/tinycontent/content/docbook/current/AsteriskDocs-html.tar.gz
Source2:	AsteriskDocs-html.tar.bz2
Source3:	asterisk-addons-%{version}.tar.bz2
Source4:	bri-stuff-0.1.0-RC4a.tar.bz2
Patch0:		asterisk-1.0.0-mdk.diff.bz2
Patch1:		asterisk-1.0.0-spandsp.diff.bz2
Patch2:		asterisk-1.0-20040912-antibork_1.diff.bz2
Patch3:		asterisk-1.0.1-bri-stuff.diff.bz2
Patch4:		asterisk-1.0.1-asterisk-addons-perl-fix.diff.bz2
PreReq:		rpm-helper
Requires:	mpg123
BuildRequires:	alsa-lib-devel
BuildRequires:	bison
BuildRequires:	db1-devel
BuildRequires:	edit-devel >= 2.9-0.20040908.2mdk
BuildRequires:	freetds-devel
BuildRequires:	glib-devel
BuildRequires:	gsm-devel >= 1.0.10-8mdk
BuildRequires:	gtk+1.2-devel
BuildRequires:	libpri-devel >= 1.0.0-2mdk
BuildRequires:	libspeex-devel
BuildRequires:	lpc10-devel
BuildRequires:	newt-devel
BuildRequires:	openh323-devel >= 1.13.5.3-2mdk
BuildRequires:	postgresql-devel
BuildRequires:	postgresql-libs-devel
BuildRequires:	readline-devel
BuildRequires:	spandsp-devel
BuildRequires:	sqlite-devel
BuildRequires:	unixODBC-devel
BuildRequires:	XFree86-devel
BuildRequires:	zaptel-devel >= 1.0.0-2mdk
BuildRequires:	libilbc-devel
BuildRequires:	swig
BuildRequires:	swig-devel
# OE: i have g723b packages, but it's a mystery how it's licensed...
#BuildRequires:	g723b-devel
# OE: can't build with mfcr2-devel installed (-DZAPATA_R2), keep getting:
# chan_zap.c: In function `handle_init_r2_event':
# chan_zap.c:5249: error: too few arguments to function `zt_new'
#BuildRequires:	mfcr2-devel
BuildRequires:	MySQL-devel
BuildRoot:	%{_tmppath}/%{name}-%{version}-root

%description
Asterisk is an Open Source PBX and telephony development platform that
can both replace a conventional PBX and act as a platform for developing
custom telephony applications for delivering dynamic content over a
telephone similarly to how one can deliver dynamic content through a
web browser using CGI and a web server.

Asterisk talks to a variety of telephony hardware including BRI, PRI, 
POTS, and IP telephony clients using the Inter-Asterisk eXchange
protocol (e.g. gnophone or miniphone).  For more information and a
current list of supported hardware, see www.asterisk.org.

BRI support was added from the bri-stuff tarball by Klaus-Peter
Junghanns: http://www.junghanns.net/

%package	plugins-pgsql
Summary:	PostgreSQL plugins for Asterisk
Group:		System/Servers
Requires:	%{name} = %{version}-%{release}

%description	plugins-pgsql
This package contains PostgreSQL plugins for Asterisk:

* Simple PostgreSQL Interface
* Call Detail Recording for PostgreSQL

%package	plugins-mysql
Summary:	MySQL plugins for Asterisk
Group:		System/Servers
Requires:	%{name} = %{version}-%{release}

%description	plugins-mysql
This package contains MySQL plugins for Asterisk:

* Call Detail Recording for MySQL

%package	plugins-odbc
Summary:	ODBC plugins for Asterisk
Group:		System/Servers
Requires:	%{name} = %{version}-%{release}

%description	plugins-odbc
This package contains ODBC plugins for Asterisk:

* ODBC Configuration
* Call Detail Recording for ODBC
* ODBC resource manager

%package	plugins-tds
Summary:	FreeTDS plugins for Asterisk
Group:		System/Servers
Requires:	%{name} = %{version}-%{release}

%description	plugins-tds
This package contains FreeTDS plugins for Asterisk:

* Call Detail Recording for FreeTDS

%package	plugins-sqlite
Summary:	SQLite plugins for Asterisk
Group:		System/Servers
Requires:	%{name} = %{version}-%{release}

%description	plugins-sqlite
This package contains SQLite plugins for Asterisk:

* Call Detail Recording for SQLite

%package	plugins-fax
Summary:	FAX plugins for Asterisk
Group:		System/Servers
Requires:	%{name} = %{version}-%{release}

%description	plugins-fax
This package contains FAX plugins for Asterisk:

* Trivial FAX Receive Application
* Trivial FAX Transmit Application
* Assign entered string to a given variable

%package	plugins-perl
Summary:	Perl plugins for Asterisk
Group:		System/Servers
Requires:	%{name} = %{version}-%{release}

%description	plugins-perl
This is res_perl the "mod_perl" of sorts for asterisk. It is an
actual live Perl Interpreter embeded in a module so when it starts
up the perl stays resident in memory the whole life of the
Asterisk process.

%package	devel
Summary:	Header files for building Asterisk modules
Group:		Development/C

%description	devel
This package contains the development header files that are needed
to compile 3rd party modules.

%package	docs
Summary:	The Hitchhiker's Guide to Asterisk
Group:		Books/Howtos

%description	docs
The Hitchhiker's Guide to Asterisk

%prep

#%setup -q -n %{name}-%{version}-%{snap} -a2 -a3
%setup -q -n %{name}-%{version} -a2 -a3 -a4
%patch0 -p1
%patch1 -p1
%patch2 -p0
%patch3 -p1
%patch4 -p0

bzcat %{SOURCE1} > asterisk.init

# lib64 fix
find -name "Makefile" | xargs perl -pi -e "s|/usr/lib|%{_libdir}|g"

# fix bri-stuff docs
mv bri-stuff* bri-stuff
rm -f bri-stuff/qozap/{*.c,*.h,Makefile,LICENSE}
rm -f bri-stuff/zaphfc/{*.c,*.h,Makefile,LICENSE}
cp bri-stuff/CHANGES CHANGES.bri-stuff
cp bri-stuff/INSTALL INSTALL.bri-stuff

%build

echo "%{version}-%{release}" > .version

make -C channels busy.h
make -C channels ringtone.h

make \
    OPTIMIZE="%{optflags} -pipe -Wall -fPIC -DPIC -D_REENTRANT -D_GNU_SOURCE" \
    ASTLIBDIR=%{_libdir} \
    ZAPDIR=%{_libdir} \
    AGI_DIR=%{_localstatedir}/asterisk/agi-bin \
    MODULES_DIR=%{_libdir}/asterisk \
    ASTVARLIBDIR=%{_localstatedir}/asterisk \
    ASTETCDIR=%{_sysconfdir}/asterisk \
    ASTSPOOLDIR=/var/spool/asterisk \
    ASTLOGDIR=/var/log/asterisk \
    ASTHEADERDIR=%{_includedir}/asterisk \
    ASTBINDIR=%{_bindir} \
    ASTSBINDIR=%{_sbindir} \
    ASTVARRUNDIR=/var/run/asterisk \
    ASTMANDIR=%{_mandir}

# make the format_mp3 asterisk-addon 
make -C asterisk-addons-%{version}/format_mp3 \
    CFLAGS="%{optflags} -pipe -Wall -fPIC -DPIC -D_REENTRANT -D_GNU_SOURCE -I../.. -I../../include" \
    OPTIMIZE="%{optflags} -pipe -Wall -fPIC -DPIC -D_REENTRANT -D_GNU_SOURCE"

# make the res_perl asterisk-addon 
perl -pi -e "s|/etc/asterisk/perl|%{_libdir}/asterisk/perl|g" asterisk-addons-%{version}/res_perl/INC/*.pm
make -C asterisk-addons-%{version}/res_perl \
    OPTIMIZE="%{optflags} -pipe -Wall -fPIC -DPIC -D_REENTRANT -D_GNU_SOURCE" \
    ASTLIBDIR=%{_libdir} \
    AGI_DIR=%{_localstatedir}/asterisk/agi-bin \
    MODULES_DIR=%{_libdir}/asterisk \
    ASTVARLIBDIR=%{_localstatedir}/asterisk \
    ASTETCDIR=%{_sysconfdir}/asterisk \
    ASTSPOOLDIR=/var/spool/asterisk \
    ASTLOGDIR=/var/log/asterisk \
    ASTHEADERDIR=%{_includedir}/asterisk \
    ASTBINDIR=%{_bindir} \
    ASTSBINDIR=%{_sbindir} \
    ASTVARRUNDIR=/var/run/asterisk \
    ASTMANDIR=%{_mandir} \
    ASTETCDIR=%{_libdir}/asterisk \

# make the muted binary
make \
    OPTIMIZE="%{optflags} -pipe -Wall -fPIC -DPIC -D_REENTRANT -D_GNU_SOURCE" \
    ASTLIBDIR=%{_libdir} \
    ZAPDIR=%{_libdir} \
    AGI_DIR=%{_localstatedir}/asterisk/agi-bin \
    MODULES_DIR=%{_libdir}/asterisk \
    ASTVARLIBDIR=%{_localstatedir}/asterisk \
    ASTETCDIR=%{_sysconfdir}/asterisk \
    ASTSPOOLDIR=/var/spool/asterisk \
    ASTLOGDIR=/var/log/asterisk \
    ASTHEADERDIR=%{_includedir}/asterisk \
    ASTBINDIR=%{_bindir} \
    ASTSBINDIR=%{_sbindir} \
    ASTVARRUNDIR=/var/run/asterisk \
    ASTMANDIR=%{_mandir} \
    muted

%install
[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}

# don't fiddle with the initscript!
export DONT_GPRINTIFY=1

install -d %{buildroot}%{_initrddir}
install -d %{buildroot}%{_sysconfdir}/logrotate.d
install -d %{buildroot}/var/run/asterisk
install -d %{buildroot}/var/log/asterisk/cdr-csv
install -d %{buildroot}/var/www/{html,cgi-bin}

make \
    INSTALL_PREFIX="%{buildroot}" \
    ASTLIBDIR=%{buildroot}%{_libdir} \
    AGI_DIR=%{buildroot}%{_localstatedir}/asterisk/agi-bin \
    MODULES_DIR=%{buildroot}%{_libdir}/asterisk \
    ASTVARLIBDIR=%{buildroot}%{_localstatedir}/asterisk \
    ASTETCDIR=%{buildroot}%{_sysconfdir}/asterisk \
    ASTSPOOLDIR=%{buildroot}/var/spool/asterisk \
    ASTLOGDIR=%{buildroot}/var/log/asterisk \
    ASTHEADERDIR=%{buildroot}%{_includedir}/asterisk \
    ASTBINDIR=%{buildroot}%{_bindir} \
    ASTSBINDIR=%{buildroot}%{_sbindir} \
    ASTVARRUNDIR=%{buildroot}/var/run/asterisk \
    ASTMANDIR=%{buildroot}%{_mandir} \
    HTTPDIR="%{buildroot}/var/www" \
    install

# fix broken softlinks
ln -snf voicemail/default %{buildroot}/var/spool/asterisk/vm
ln -snf ../../../spool/asterisk/vm %{buildroot}%{_localstatedir}/asterisk/sounds
ln -snf ../../../spool/asterisk/voicemail %{buildroot}%{_localstatedir}/asterisk/sounds/voicemail
ln -snf ../../../spool/asterisk/voicemail %{buildroot}/var/spool/asterisk/voicemail

# install init scrips
install -m0755 asterisk.init %{buildroot}%{_initrddir}/asterisk

# fix man page
gunzip %{buildroot}%{_mandir}/man8/asterisk.8*

# fix config files
perl -pi -e "s|%{buildroot}||g" %{buildroot}%{_sysconfdir}/asterisk/*

# install the h323 conf file
install -m0644 channels/h323/h323.conf.sample %{buildroot}%{_sysconfdir}/asterisk/h323.conf

# install the format_mp3 asterisk-addon stuff
install -m0755 asterisk-addons-%{version}/format_mp3/format_mp3.so %{buildroot}%{_libdir}/asterisk/
cp asterisk-addons-%{version}/format_mp3/MPGLIB_README README.MPGLIB
cp asterisk-addons-%{version}/format_mp3/README README.format_mp3

# install the perl asterisk-addon stuff
make -C asterisk-addons-%{version}/res_perl \
    INSTALL_PREFIX="%{buildroot}" \
    ASTLIBDIR=%{buildroot}%{_libdir} \
    AGI_DIR=%{buildroot}%{_localstatedir}/asterisk/agi-bin \
    MODULES_DIR=%{buildroot}%{_libdir}/asterisk \
    ASTVARLIBDIR=%{buildroot}%{_localstatedir}/asterisk \
    ASTETCDIR=%{buildroot}%{_sysconfdir}/asterisk \
    ASTSPOOLDIR=%{buildroot}/var/spool/asterisk \
    ASTLOGDIR=%{buildroot}/var/log/asterisk \
    ASTHEADERDIR=%{buildroot}%{_includedir}/asterisk \
    ASTBINDIR=%{buildroot}%{_bindir} \
    ASTSBINDIR=%{buildroot}%{_sbindir} \
    ASTVARRUNDIR=%{buildroot}/var/run/asterisk \
    ASTMANDIR=%{buildroot}%{_mandir} \
    ASTETCDIR=%{buildroot}%{_libdir}/asterisk \
    install

# fix two naughty bugs
perl -pi -e "s|/usr/local|/usr|g" %{buildroot}%{_libdir}/asterisk/perl/WebServer.pm

# fix logrotation
cat > %{buildroot}%{_sysconfdir}/logrotate.d/asterisk << EOF
/var/log/asterisk/console /var/log/asterisk/messages /var/log/asterisk/queue_log /var/log/asterisk/event_log /var/log/asterisk/cdr-csv/Master.csv {
    weekly
    rotate 5
    copytruncate
    compress
    notifempty
    missingok
    postrotate
      %{_sbindir}/asterisk -rx 'reload'
    endscript
}
EOF

# install the muted stuff
install -m0755 muted %{buildroot}%{_sbindir}/
install -m0644 muted.conf.sample %{buildroot}%{_sysconfdir}/muted.conf

cat > README.MDK << EOF
T O D O
-------

* ?


E R R A T A
-----------

The MOH (music on hold) and in several other places of the sourcecode 
(app_meetme.c, app_zapbarge.c,app_zapscan.c,chan_iax2.c,chan_zap.c,
res_musiconhold.c,zaptel.c,ztmonitor.c,zttest.c) a /dev/zap/pseudo
device is needed. This device is vendor specific. The source lacks 
ifdefs in many places that would enable usage of another device.

The MOH feature requires a timing device, and currently the 
/dev/zap/pseudo device is used for that also (or the ztdummy.c kernel 
module from the zaptel kernel module source). 

There is another timing device (actually a kernel module) named zaprtc 
found at http://www.junghanns.net/ but it seems it will clash with dual
CPU systems (HT, etc.) because of the internal kernel use of the
vanilla rtc kernel module.

R E F L E C T I O N S
---------------------

I would say this software is pretty much locked to one vendor at this
point. So if you don't go and buy hardware from the author, you will 
experience problems...

Regards // Oden Eriksson
EOF


#%pre
#%_pre_useradd asterisk %{_localstatedir}/asterisk /bin/sh

%post
%_post_service asterisk

%preun
%_preun_service asterisk

#%postun
#%_postun_userdel asterisk

%clean
[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc BUGS ChangeLog CREDITS HARDWARE LICENSE README* SECURITY sounds.txt apps/rpt_flow.pdf
%doc doc/*README* doc/*.txt contrib/init.d/rc.mandrake* contrib/asterisk-ices.xml
%doc contrib/scripts contrib/i18n.testsuite.conf contrib/README.festival
%doc bri-stuff/qozap bri-stuff/zaphfc CHANGES.bri-stuff INSTALL.bri-stuff
%config(noreplace) %attr(0755,root,root) %{_initrddir}/asterisk
%config(noreplace) %attr(0644,root,root) %{_sysconfdir}/logrotate.d/asterisk
%attr(0755,root,root) %dir %{_sysconfdir}/asterisk
%config(noreplace) %attr(0644,root,root) %{_sysconfdir}/asterisk/*.conf
%config(noreplace) %attr(0644,root,root) %{_sysconfdir}/asterisk/*.adsi
%config(noreplace) %attr(0644,root,root) %{_sysconfdir}/muted.conf
%exclude %{_sysconfdir}/asterisk/*sql*.conf
%exclude %{_sysconfdir}/asterisk/*odbc*.conf
%exclude %{_sysconfdir}/asterisk/*tds*.conf
%attr(0755,root,root) %{_sbindir}/*
%attr(0755,root,root) %{_libdir}/asterisk/app_*.so
%attr(0755,root,root) %{_libdir}/asterisk/cdr_*.so
%attr(0755,root,root) %{_libdir}/asterisk/chan_*.so
%attr(0755,root,root) %{_libdir}/asterisk/codec_*.so
%attr(0755,root,root) %{_libdir}/asterisk/format_*.so
%attr(0755,root,root) %{_libdir}/asterisk/pbx_*.so
%attr(0755,root,root) %{_libdir}/asterisk/res_*.so
%exclude %{_libdir}/asterisk/*sql*.so
%exclude %{_libdir}/asterisk/*odbc*.so
%exclude %{_libdir}/asterisk/*tds*.so
%exclude %{_libdir}/asterisk/*sqlite*.so
%exclude %{_libdir}/asterisk/app_*fax.so
%exclude %{_libdir}/asterisk/app_dtmftotext.so
%exclude %{_libdir}/asterisk/res_perl.so
%exclude %{_libdir}/asterisk/perl
%attr(0644,root,root) %{_localstatedir}/asterisk/sounds/*.gsm
%attr(0644,root,root) %{_localstatedir}/asterisk/sounds/digits/*.gsm
%attr(0644,root,root) %{_localstatedir}/asterisk/sounds/letters/*.gsm
%attr(0644,root,root) %{_localstatedir}/asterisk/sounds/phonetic/*.gsm
%attr(0644,root,root) %{_localstatedir}/asterisk/mohmp3/*
%attr(0644,root,root) %{_localstatedir}/asterisk/images/*
%attr(0644,root,root) %{_localstatedir}/asterisk/keys/*
%attr(0755,root,root) %{_localstatedir}/asterisk/agi-bin/*
%attr(0755,root,root) %{_localstatedir}/asterisk/firmware/iax/*.bin
%attr(0644,root,root) /var/spool/asterisk/voicemail/default/1234/*.gsm
%attr(0755,root,root) %{_localstatedir}/asterisk/sounds/vm
%attr(0755,root,root) %{_localstatedir}/asterisk/sounds/voicemail
%attr(0755,root,root) /var/spool/asterisk/vm
%attr(0755,root,root) /var/spool/asterisk/voicemail/voicemail
%attr(0755,root,root) %dir /var/log/asterisk
%attr(0755,root,root) %dir /var/log/asterisk/cdr-csv
%attr(0755,root,root) %dir /var/run/asterisk
%{_mandir}/man8/asterisk.8*
%attr(4755,root,root) /var/www/cgi-bin/vmail.cgi
%attr(0644,root,root) /var/www/html/_asterisk/animlogo.gif
%attr(0644,root,root) /var/www/html/_asterisk/play.gif

%files plugins-pgsql
%defattr(-,root,root)
%config(noreplace) %attr(0644,root,root) %{_sysconfdir}/asterisk/cdr_pgsql.conf
%attr(0755,root,root) %{_libdir}/asterisk/app_sql_postgres.so
%attr(0755,root,root) %{_libdir}/asterisk/cdr_pgsql.so

%files plugins-mysql
%defattr(-,root,root)
%config(noreplace) %attr(0644,root,root) %{_sysconfdir}/asterisk/cdr_mysql.conf
%attr(0755,root,root) %{_libdir}/asterisk/cdr_mysql.so

%files plugins-odbc
%defattr(-,root,root)
%config(noreplace) %attr(0644,root,root) %{_sysconfdir}/asterisk/*odbc*.conf
%attr(0755,root,root) %{_libdir}/asterisk/*odbc*.so

%files plugins-tds
%defattr(-,root,root)
%config(noreplace) %attr(0644,root,root) %{_sysconfdir}/asterisk/cdr_tds.conf
%attr(0755,root,root) %{_libdir}/asterisk/cdr_tds.so

%files plugins-sqlite
%defattr(-,root,root)
%attr(0755,root,root) %{_libdir}/asterisk/cdr_sqlite.so

%files plugins-fax
%defattr(-,root,root)
%attr(0755,root,root) %{_libdir}/asterisk/app_*fax.so
%attr(0755,root,root) %{_libdir}/asterisk/app_dtmftotext.so

%files plugins-perl
%defattr(-,root,root)
%doc asterisk-addons-%{version}/res_perl/README
%attr(0755,root,root) %{_libdir}/asterisk/res_perl.so
%attr(0755,root,root) %{_libdir}/asterisk/perl

%files devel
%defattr(-,root,root)
%attr(0644,root,root) %{_includedir}/asterisk/*.h

%files docs
%defattr(-,root,root)
%doc docs-html/*

%changelog
* Mon Oct 04 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 1.0.1-2mdk
- oops!, have to hack the perl stuff some more before building it...

* Mon Oct 04 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 1.0.1-1mdk
- 1.0.1
- rediffed P3
- added the perl stuff

* Mon Sep 27 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 1.0.0-4mdk
- fixed P1 (gsm and ilbc is shared libraries now)
- openh323-devel seemed borked, require >= 1.13.5.3-2mdk

* Sun Sep 26 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 1.0.0-3mdk
- fixed P1
- added P3 by Klaus-Peter Junghanns

* Sun Sep 26 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 1.0.0-2mdk
- add one small fix in P0 and also mention that fragments of it 
  originates from debian.

* Fri Sep 24 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 1.0.0-1mdk
- 1.0.0
- fix url

* Wed Sep 22 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 1.0-0.20040916.3mdk
- Rebuild with latest pwlib/openh323

* Tue Sep 21 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 1.0-0.20040916.2mdk
- fix BuildRequires (Stefan van der Eijk <stefan@eijk.nu>)

* Thu Sep 16 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 1.0-0.20040916.1mdk
- 20040916
- fix some bugs
- fix P0
- broke out some of the stuff into their respective plugins sub packages
- added the muted stuff
- added the README.MDK file

* Tue Sep 14 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 1.0-0.20040914.1mdk
- 20040914
- make it compile on cooker too
- merged P0 - P8 -> P0
- added the cdr_mysql code from the asterisk-addons package (merged into P0)
- added format_mp3 asterisk-addon stuff from the asterisk-addons package
- added the docs from http://www.asteriskdocs.org/

* Mon Sep 13 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 1.0-0.20040912.1mdk
- 20040912
- rediff P0
- added the spandsp addon (P2)
- added logrotate stuff

* Sun Sep 12 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 1.0-0.RC2.2mdk
- fix the patches
- added P2, P3, P4, P5, P6 & P7

* Fri Sep 10 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 1.0-0.RC2.1mdk
- initial mandrake package
- used the provided spec file by Robert Vojta as a template
- added P0 & P1
